VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "FileScaner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private word_ As API_WordWrapper
Private doc_ As Word.Document

Public Function Init()
  Set word_ = New API_WordWrapper
  Call word_.CreateApplication(bIsVisible:=True)
End Function

Public Function Finalize()
  Call word_.ReleaseApplication
  Set word_ = Nothing
End Function

Public Function Process(sFile$) As Long
  If word_.OpenDocument(sFile, bReadOnly:=True) Is Nothing Then _
    Exit Function
    
  Process = ProcessDocument(word_.Document)
  
  Call word_.ReleaseDocument(bCloseApplication:=False)
End Function

Public Function ProcessDocument(target As Word.Document) As Long
  Set doc_ = target
  
  Dim sProject$: sProject = ExtractProject
  Dim dDate As Double: dDate = ExtractDate
  
  Dim nSourceID&: nSourceID = AddSource(sProject, doc_.FullName)
  ProcessDocument = ProcessTasks(dDate, sProject, nSourceID)
  
  Set doc_ = Nothing
End Function

' =======
Private Function ProcessTasks(dDate As Double, sProject$, nSourceID&) As Long
  Dim taskRange As Word.Range: Set taskRange = doc_.Range
  With taskRange.Find
    .Text = ":"
    .MatchCase = True
    If Not .Execute Then _
      Exit Function
  End With
  
  taskRange.Start = taskRange.End + 2
  taskRange.End = doc_.Range.End
  
  Dim aPara As Word.Paragraph
  Dim nPara
  For nPara = taskRange.Paragraphs.Count To 1 Step -1
    Set aPara = taskRange.Paragraphs(nPara)
    Dim sText$: sText = SubstituteWhitespace(aPara.Range.Text)
    If sText <> vbNullString Then
      If AddTaskInternal(sText, dDate, sProject, nSourceID, doc_.FullName) Then _
        ProcessTasks = ProcessTasks + 1
    End If
  Next nPara
End Function

Private Function AddTaskInternal(ByRef sText$, dDate As Double, sProject$, nSourceID&, sFile$) As Boolean
  AddTaskInternal = False
  
  Dim nDelim&: nDelim = VBA.InStrRev(sText, "@@")
  If nDelim = 0 Then _
    Exit Function
    
  Dim sResponsible$: sResponsible = VBA.Right(sText, VBA.Len(sText) - nDelim - 1)
  sText = VBA.Left(sText, VBA.Len(sText) - VBA.Len(sResponsible) - 2)
  sText = TrimEndPunctuation(sText)
  Call AddTask(dDate, sProject, VBA.Trim(sText), VBA.Trim(sResponsible), nSourceID, sFile)
  
  AddTaskInternal = True
End Function

Private Function ExtractProject() As String
  On Error Resume Next
  ExtractProject = TrimWhitespace(doc_.Tables(1).Cell(1, 3).Range.Text)
End Function

Private Function ExtractDate() As Double
  On Error Resume Next
  Dim sDate$: sDate = TrimWhitespace(doc_.Tables(1).Cell(3, 2).Range.Text)
  If Len(sDate) <= 2 Then _
    Exit Function
  ExtractDate = DateValue(sDate)
End Function
