VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "s_FileScaner"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private iScaner_ As FileScaner
Private word_ As API_WordWrapper
Private doc_ As Word.Document

Public Function Setup()
  ' Mandatory setup function
  Set word_ = New API_WordWrapper: Call word_.CreateApplication
  Set doc_ = word_.NewDocument
  Set iScaner_ = New FileScaner
End Function

Public Function Teardown()
  ' Mandatory teardown function
  Call word_.ReleaseDocument
  Call ClearAll
End Function

Public Function t_EmptyFile()
  On Error GoTo PROPAGATE_ERROR
  
  Call Dev_ExpectEQ(0, iScaner_.ProcessDocument(doc_), "Do not scan tasks")
  Call Dev_ExpectEQ(1, Sources().Count, "Add source")
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function

Public Function t_ScanContents()
  On Error GoTo PROPAGATE_ERROR
  
  Dim iTasks As Excel.Worksheet: Set iTasks = ThisWorkbook.Sheets(SHEET_TASKS)
  
  Dim iTable As Word.Table: Set iTable = doc_.Tables.Add(doc_.Range, 3, 3)
  iTable.Cell(1, 3).Range.Text = "Project"
  iTable.Cell(3, 2).Range.Text = "2005-01-12"
  Dim dDate As Double: dDate = VBA.DateValue("2005-01-12")
  
  Call doc_.Range.InsertAfter(":" & vbNewLine)
  Call doc_.Range.InsertAfter("Task 1@@" & vbNewLine)
  Call doc_.Range.InsertAfter("Task 2 @@Person")
  
  Call Dev_ExpectEQ(2, iScaner_.ProcessDocument(doc_), "Task count")
  Call Dev_ExpectEQ(1, Sources().Count, "Add source")

  Call Dev_NewCase("Task without responsible")
  Call Dev_ExpectEQ(2, iTasks.Cells(FIRST_ROW, S_TASK_ID))
  Call Dev_ExpectEQ(dDate, iTasks.Cells(FIRST_ROW, S_TASK_DATE))
  Call Dev_ExpectEQ(T_TT_OPEN, iTasks.Cells(FIRST_ROW, S_TASK_STATUS))
  Call Dev_ExpectEQ("Project", iTasks.Cells(FIRST_ROW, S_TASK_PROJECT))
  Call Dev_ExpectEQ("Task 1", iTasks.Cells(FIRST_ROW, S_TASK_TEXT))
  Call Dev_ExpectEQ("", iTasks.Cells(FIRST_ROW, S_TASK_RESPONSIBLE))
  Call Dev_ExpectEQ(1, iTasks.Cells(FIRST_ROW, S_TASK_SOURCE_ID))
  
  Call Dev_NewCase("Task with responsible")
  Call Dev_ExpectEQ(1, iTasks.Cells(FIRST_ROW + 1, S_TASK_ID))
  Call Dev_ExpectEQ(dDate, iTasks.Cells(FIRST_ROW + 1, S_TASK_DATE))
  Call Dev_ExpectEQ(T_TT_OPEN, iTasks.Cells(FIRST_ROW + 1, S_TASK_STATUS))
  Call Dev_ExpectEQ("Project", iTasks.Cells(FIRST_ROW + 1, S_TASK_PROJECT))
  Call Dev_ExpectEQ("Task 2", iTasks.Cells(FIRST_ROW + 1, S_TASK_TEXT))
  Call Dev_ExpectEQ("Person", iTasks.Cells(FIRST_ROW + 1, S_TASK_RESPONSIBLE))
  Call Dev_ExpectEQ(1, iTasks.Cells(FIRST_ROW + 1, S_TASK_SOURCE_ID))
  
  Exit Function
PROPAGATE_ERROR:
  Call Dev_LogError(Err.Number, Err.Description)
End Function
